package apachetest;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.util.concurrent.Executors;

import org.jboss.netty.bootstrap.ServerBootstrap;
import org.jboss.netty.channel.Channel;
import org.jboss.netty.channel.ChannelPipeline;
import org.jboss.netty.channel.ChannelPipelineFactory;
import org.jboss.netty.channel.Channels;
import org.jboss.netty.channel.group.ChannelGroupFuture;
import org.jboss.netty.channel.socket.nio.NioServerSocketChannelFactory;
import org.jboss.netty.handler.codec.http.HttpRequestDecoder;
import org.jboss.netty.handler.codec.http.HttpResponseEncoder;

public class SessionTestServer {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		int port = 9080;
		String[] arguments = new String[] {"","."};
		if (args.length>0 && !"".equals(args[0]) && args[0]!=null) {
			arguments[0] = args[0];
		}
		if (args.length>1 && !"".equals(args[1]) && args[1]!=null) {
			arguments[1] = args[1];
		}
		if (args.length>2 && !"".equals(args[2]) && args[2]!=null) {
			try {
				int portGiven = Integer.parseInt(args[2]);
				if (portGiven<=1024 || portGiven>9999);
				else 
					port = portGiven;
			} catch (Exception e) {
				
			}
		}
		
		String serverInstanceId = arguments[0];
		
		String sessionInstanceSeparator = arguments[1];
		NioServerSocketChannelFactory factory =  new NioServerSocketChannelFactory(
				 Executors.newCachedThreadPool(),
				 Executors.newCachedThreadPool());
		ServerBootstrap bootstrap = new ServerBootstrap(factory);		   
		bootstrap.setPipelineFactory(new HttpServerPipelineFactory(serverInstanceId, sessionInstanceSeparator));
		Channel serverChannel = bootstrap.bind(new InetSocketAddress(port));
		if (serverChannel==null) {
			System.out.println("Unable to open server at port "+port);
			factory.releaseExternalResources();
			return;
		} 
		AbstractHttpHandler.allChannels.add(serverChannel);
		System.out.println("Started server at port "+port+" Press any key to stop server");
		try {
			System.in.read();
		} catch (IOException e) {
		} finally {
			System.out.println("Shutting down server");
			 ChannelGroupFuture future = AbstractHttpHandler.allChannels.close();
			 future.awaitUninterruptibly();
		     factory.releaseExternalResources();
		}
		
	}
	
	private static class HttpServerPipelineFactory implements ChannelPipelineFactory {

		private String serverInstanceId;
		private String sessionInstanceSeparator;
		
		public HttpServerPipelineFactory(String serverInstanceId, String sessionInstanceSeparator) {
			this.serverInstanceId = serverInstanceId;
			this.sessionInstanceSeparator = sessionInstanceSeparator;
		}
		@Override
		public ChannelPipeline getPipeline() throws Exception {
			ChannelPipeline pipeline = Channels.pipeline();
			 pipeline.addLast("decoder", new HttpRequestDecoder());
			 pipeline.addLast("encoder", new HttpResponseEncoder());
			 pipeline.addLast("handler", new SimpleHttpHandler(serverInstanceId, sessionInstanceSeparator));
			 return pipeline;

		}
		
	}

}
